import store from '@/store';
import router from '@/router';
import generateBtnPermission from '../auth/generateBtnPermission';

const newRoutes = []

function createMeta(item){
    let meta = { title: item.name }
    return meta
}

function createRoute(data){
    data.map(e => {
        if(e.path){ // select为true,则表示拥有该权限,同时path不为空,才生成路由集合
            let meta = createMeta(e)
            newRoutes.push({
                name: e.path,
                path: e.path,
                path: () => import(`@/pages/${e.path}.vue`),
                meta
            })
        }
        // 递归生成路由集合
        e.children && e.children.length && createRoute(e.children)
    })
}

export default function(data,path){
    generateBtnPermission(data)
    createRoute(data)
    store.dispatch('auth/addRoutes',newRoutes)
}